/*
  $Id: CppCodeGenerator.h,v 1.7 1997/02/21 06:35:30 matt Exp $

  C++ code generator class.

  (c) Matt Phillips 1996.
  */

#ifndef _CPP_CODE_GENERATOR_H
#define _CPP_CODE_GENERATOR_H

#include <iostream.h>

#include <foo/FooObject.h>
#include <CodeFrags.h>

class CppCodeGenerator
{
public:

  CppCodeGenerator (const FooObject &s, istream &cf,
		    ostream &h, ostream &b);

  int nErrors () const {return errors;}

protected:

  const FooObject &scandef;
  CodeFrags codefrags;
  ostream &header, &body;
  string errorProduction;
  int errors;

  void doHeader ();
  void doBody ();

  // utility functions
  void doOutputChar (unsigned char chr);

  // header subroutines
  void doTokenSymbols ();
  void doProdSymbols ();
  void doProdDecls ();

  // body subroutines
  void doEdgeLists ();
  void doStates ();
  void doEdgeList (const FooObject::Objects &edges,
		   const string &stateNo);
  void doProdFuncsTable (const string &scannerName);
  void doProdBodies (const string &scannerName);
};

#endif
