/*
  $Id: ContainerIter.h,v 1.2 1996/05/19 03:59:31 matt Exp $

  Generic iterators.
  
  Sep 18th 1994 Matt Phillips.
  */

#ifndef _CONTITER_H
#define _CONTITER_H

#define ITER_BOUND(p) 	CHECK(p, "iterator out of bounds")
#define ITER_CURRENT(p)	CHECK(p, "iterator not current")

template <class T>
class ContainerIter
{
public:
   
   virtual ~ContainerIter () {}
   
   virtual void reset () = 0;
   virtual operator int () const = 0;
   virtual void operator ++ (int) = 0;
   virtual T &ref () const = 0;
};

template <class T>
class RContainerIter : public ContainerIter<T>
{
public:
   
   virtual void operator -- (int) = 0;
   virtual void reset () {resetStart ();}
   virtual void resetStart () = 0;
   virtual void resetEnd () = 0;
};

#endif
