/*
  $Id: Deque.h,v 1.2 1997/02/02 01:31:03 matt Exp $

  Deques class.
  
  Sep 18th 1994 Matt Phillips.
  */

#ifndef _DEQUES_H
#define _DEQUES_H

#include "ContainerPresentation.h"

#define DEQUE_PEEK(p) CHECK(p, "peek on empty deque")
#define DEQUE_REMOVE ABORT("remove on empty deque")

//////////////// Deques

template <class T>
class Deque : public ContainerPresentation<T>
{
public:
   
   virtual const char *name () const {return "Deque";}
   
   virtual void addHead (T &i) = 0;
   virtual void addTail (T &i) = 0;
   virtual void removeHead () = 0;
   virtual void removeTail () = 0;
   
   virtual T &peekHead () const = 0;
   virtual T &peekTail () const = 0;
};

template <class T>
class DequeIter : public RContainerIter<T>
{
};

#endif
