/*
  $Id: LinkedAssocItem.h,v 1.2 1997/02/02 01:31:03 matt Exp $

  Linked AssocItem class.

  (c) Apr 10 1996 Matt Phillips.
  */

#ifndef _LASSOC_H
#define _LASSOC_H

#include "AssociationItem.h"

template <class K, class T>
class DLinkedAssocItem : public DAssocItem<K, T>
{
public:

  DLinkedAssocItem (const K &k, T &v, DLinkedAssocItem<K, T> *n = 0) :
    DAssocItem<K, T> (k, v), next (n) {}

  DLinkedAssocItem<K, T> *next;
};

template <class K, class T, int ownsT>
class ITLinkedAssocItem : public ITAssocItem<K, T, ownsT>
{
public:

  ITLinkedAssocItem (const K &k, T &v, ITLinkedAssocItem<K, T, ownsT> *n = 0) :
    ITAssocItem<K, T, ownsT> (k, v), next (n) {}

  ITLinkedAssocItem<K, T, ownsT> *next;
};

#endif
