/*
  $Id: Stack.h,v 1.2 1997/02/02 01:31:04 matt Exp $

  Generic stacks.
  
  (c) Sep 20th Matt Phillips.
  */

#ifndef _STACKS_H
#define _STACKS_H

#include "ContainerPresentation.h"

#define STACK_OVERFLOW(p)	CHECK(p, "stack overflow");
#define STACK_UNDERFLOW(p)	CHECK(p, "stack underflow");

template <class T>
class Stack : public ContainerPresentation<T>
{
public:
   
  virtual const char *name () const {return "Stack";}
   
  virtual void push (T &i) = 0;
  virtual void pop () = 0;
  virtual T &top () const = 0;
};

#endif
