/*
  $Id: TreeAssocItem.h,v 1.2 1997/02/02 01:31:04 matt Exp $

  Tree assoc item class.

  (c) Apr 12 1996 Matt Phillips.
  */

#ifndef _TASSOC_H
#define _TASSOC_H

#include "AssociationItem.h"

template <class K, class T>
class DTreeAssocItem : public DAssocItem<K, T>
{
public:

  DTreeAssocItem (const K &k, T &i) : DAssocItem<K, T> (k, i)
  {left = right = 0;}

  DTreeAssocItem<K, T> *left, *right;
};

template <class K, class T, int ownsT>
class ITTreeAssocItem : public ITAssocItem<K, T, ownsT>
{
public:

  ITTreeAssocItem (const K &k, T &i) : ITAssocItem<K, T, ownsT> (k, i)
  {left = right = 0;}

  ITTreeAssocItem<K, T, ownsT> *left, *right;
};

// null << operators
template <class K, class T>
inline ostream &operator << (ostream &os, const DTreeAssocItem<K, T> &)
{
  return os;
}

template <class K, class T, int ownsT>
inline ostream &operator << (ostream &os, const ITTreeAssocItem<K, T, ownsT> &)
{
  return os;
}

#endif
