/*
  $Id: ElexScannerData.cpp,v 1.2 1997/02/02 01:30:59 matt Exp $

  Elex C++ scanner data classes
  
  (c) Jan 96 Matt Phillips
*/

#include "ElexScannerData.h"

ElexState *ElexEdges::getTarget (uchar chr) const
{
  // left/right boundaries
  int left = 0, right = nEdges - 1;

  while (left <= right)
  {
    int midpoint = (left + right) / 2;
    ElexEdge *e = edges + midpoint;

    if (chr < e->lower)
      right = midpoint - 1;
    else if (chr > e->upper)
      left = midpoint + 1;
    else
      return e->target;
  }

  return 0;
}
