/*
  $Id: ElexScannerData.h,v 1.3 1997/02/20 09:44:28 matt Exp $

  Elex C++ scanner data classes
  
  (c) Jan 96 Matt Phillips
*/

#ifndef ELEX_SCANDATA_H
#define ELEX_SCANDATA_H

typedef unsigned char uchar;

class ElexState;

class ElexEdge
{
public:

  uchar lower, upper;
  ElexState *target;
};

class ElexEdges
{
public:

  ElexEdge *edges;
  int nEdges;

  // returns the target state for a transition on <chr>, or null if
  // no such transition exists
  ElexState *getTarget (uchar chr) const;
};

class ElexState
{
public:

  enum {NoProduction = -1, DefaultErrorProduction = -2};

  ElexEdges *edges;
  int prod;

  ElexState *getTarget (uchar chr) const
  {return edges ? edges->getTarget (chr) : 0;}

  int isFinal () const {return prod != NoProduction;}
};

class ElexScannerData
{
public:

  ElexState *start;
  int errorProd;
};

#endif
