/*
  $Id: ElexScannerDef.h,v 1.6 1997/02/21 06:37:07 matt Exp $

  Elex scanner definition.
  
  (c) Jan 96 Matt Phillips.
  */

#ifndef _ELEXSDEF_H

#define _ELEXSDEF_H

#include <std/string.h>
#include <contain/LinkedList.h>
#include <contain/LinkedListWithTail.h>
#include <contain/ClosedHash.h>
#include <fsm/Fsm.h>

class ElexScannerDef
{
public:

  enum {HashSize = 256};

  class Hash
  {
  public:
    
    static int hash (int v) {return v % HashSize;}
  };

  class CodeStream;

  typedef TypeDLinkedListWithTail (string) Productions;
  typedef TypeDSortedLinkedListUnique (string) Tokens;

  string name, base;
  Fsm fsm;
  Productions productions;
  Tokens tokens;
  int prodNo;

  ElexScannerDef () : prodNo (1) {}

  void outputScanner (ostream &s);

protected:

  void outputTokens (CodeStream &cs);
  void outputProductions (CodeStream &cs);
  void outputStates (CodeStream &cs);
};

#endif
