/*
  $Id: FooParser.h,v 1.2 1997/02/02 01:31:01 matt Exp $

  FooParser class.

  (c) 1996 Matt Phillips.
  */

#ifndef _FOO_PARSER_H
#define _FOO_PARSER_H

#include <compiler/BufferedInputStream.h>
#include <compiler/ErrorMessage.h>

#include "FooScanner.h"
#include "FooObject.h"

class FooParser
{
public:
   
  // constructor
  FooParser (BufferedInputStream &i);

  int nErrors () const {return errors.nErrors ();}
  int nWarnings () const {return errors.nWarnings ();}

  FooObject &getObject () {return *baseObject;}

  ErrorMessageList &getErrors () {return errors;}

protected:

  FooScanner scanner;
  ErrorMessageList errors;
  FooObject *baseObject;

  // errors
  void error (const char *msg);
  void warning (const char *msg);

  // parser subs
  FooObject *parseObject ();
  void parseAttrs (FooObject &object);

  // error handling
  int mustbe (int sym);
  void mustbeError (int sym);
  int have (int sym);
};

#endif
