/*
  $Id: FsmEdge.cpp,v 1.2 1997/02/02 01:31:02 matt Exp $

  FSM edge class.
  
  (c) Feb 1995 Matt Phillips.
  */

#include "FsmEdge.h"
#include "FsmState.h"

ostream &operator << (ostream &os, const FsmEdge &edge)
{
   if (edge.isEpsilon ())
      os << "<epsilon>";
   else
      os << (UCharRange &)edge;

   os << " -> " << edge.target->getID ();
   
   return os;
}

// an epsilon edge is <= any edge
int FsmEdge::operator <= (const FsmEdge &e) const
{return epsilon || UCharRange::operator == (e) && *(target) <= *(e.target) ||
 UCharRange::operator < (e);}

int FsmEdge::operator < (const FsmEdge &e) const
{return epsilon || UCharRange::operator == (e) && *(target) < *(e.target) ||
 UCharRange::operator < (e);}

