/*
  $Id: RegexpScanner.h,v 1.4 1997/02/02 01:31:06 matt Exp $

  Regular expression scanner class.
  
  (c) Apr 1996 Matthew Phillips.
  */

#ifndef _RESCAN_H
#define _RESCAN_H

#include <compiler/Scanner.h>

class RegexpScanner : public Scanner
{
public:

  // the order of the symbols below is important
  enum {SymChar, SymDot, SymVariable, SymLBracket, SymLSBracket,
	SymTilde, SymQuestion, SymCaret, SymStar, SymPlus,
	SymMinus, SymRBracket, SymRSBracket, SymBar};

  RegexpScanner (BufferedInputStream &i, ErrorMessageList &e)
    : Scanner (i, e) {}

  void getNext ();

protected:

  int handleVariable ();
  int handleBackslash ();
  char readHexNum ();
  char readDecNum ();
};

#endif
