/*
  $Id: OrderedPair.h,v 1.1 1996/04/08 08:56:20 matt Exp $

  Generic ordered scalar pairs class.

  (c) May 95 Matt Phillips.
  */

#ifndef _ORDPAIR_H
#define _ORDPAIR_H

#include <iostream.h>

#include "swap.h"

template <class T>
class OrderedPair
{
public:

  OrderedPair (T i1, T i2) : item1 (i1), item2 (i2) {normalize ();}

  OrderedPair (const OrderedPair<T> &p) : item1 (p.item1), item2 (p.item2) {}

  int operator == (const OrderedPair<T> &p) const
  {return item1 == p.item1 && item2 == p.item2;}

  int operator < (const OrderedPair<T> &p) const
  {return item1 < p.item1;}

  int operator <= (const OrderedPair<T> &p) const
  {return item1 <= p.item1;}

  void normalize () {if (item1 > item2) swap (item1, item2);}

  T item1, item2;
};

template <class T>
ostream &operator << (ostream &os, const OrderedPair<T> &p)
{
  os << '(' << p.item1 << ", " << p.item2 << ')';
  return os;
}

#endif
